unit CustGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, ExtCtrls, amdi;

type
  TCustomerGrid = class(TForm)
    Panel1: TPanel;
    InsertButton: TButton;
    EditButton: TButton;
    DeleteButton: TButton;
    SelectButton: TButton;
    CloseButton: TButton;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table1Addr1: TStringField;
    Table1Addr2: TStringField;
    Table1City: TStringField;
    Table1State: TStringField;
    Table1Zip: TStringField;
    Table1Country: TStringField;
    Table1Phone: TStringField;
    Table1FAX: TStringField;
    Table1TaxRate: TFloatField;
    Table1Contact: TStringField;
    Table1LastInvoiceDate: TDateTimeField;
    procedure CloseButtonClick(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure EditButtonClick(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CustomerGrid: TCustomerGrid;

procedure DoCustomerGrid(Sender: TAMDIEngine;ParentForm:TForm);

implementation

{$R *.DFM}
uses custcard;

procedure DoCustomerGrid(Sender: TAMDIEngine;ParentForm:TForm);
begin
  with Sender do
  begin
    NewForm(TCustomerGrid);
    if ParentForm<>nil then
      with ActiveForm as TCustomerGrid do
      begin
        SelectButton.Visible:=true;
        DBGrid1.OnDblClick:=SelectButtonClick;
      end;
    ShowForm;
    while Not (Terminated or (ActiveState=AMDICloseState)) do
    begin
      case ActiveState of
      1,2:
        begin
          ActiveState:=0;
          DoCustomerCard(Sender,ActiveForm);
        end;
      3:
        begin
          ActiveState:=0;
          if ParentForm<>nil then
            ;
          break;
        end;
      else
        sleep(100);
      end;
    end;
    CloseForm;
  end;
end;

procedure TCustomerGrid.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TCustomerGrid.InsertButtonClick(Sender: TObject);
var LastNo:integer;
begin
  { Init fields }
  if Table1.isEmpty then
    LastNo:=1
  else
  begin
    Table1.IndexFieldNames:='CustNo';
    Table1.Last;
    LastNo:=Table1.FieldByName('CustNo').asInteger+1;
    Table1.IndexFieldNames:='Company';
  end;
  Table1.Insert;
  Table1.FieldByName('CustNo').asInteger:=LastNo;
  AMDIEngines.States[Self]:=1; { Do Insert }
end;

procedure TCustomerGrid.EditButtonClick(Sender: TObject);
begin
  if not Table1.IsEmpty then
  begin
    Table1.Edit;
    AMDIEngines.States[Self]:=2; { Do Edit }
  end;
end;

procedure TCustomerGrid.SelectButtonClick(Sender: TObject);
begin
  if not Table1.IsEmpty then
  begin
    AMDIEngines.States[Self]:=3; {Do Select}
  end;
end;

procedure TCustomerGrid.DeleteButtonClick(Sender: TObject);
begin
  if not Table1.IsEmpty then
  begin
    if MessageDlg('Delete this record?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      Table1.Delete;
  end;
end;

end.
