unit EmplGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, Grids, DBGrids, ExtCtrls, amdi;

type
  TEmployeeGrid = class(TForm)
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    InsertButton: TButton;
    EditButton: TButton;
    DeleteButton: TButton;
    SelectButton: TButton;
    CloseButton: TButton;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1EmpNo: TIntegerField;
    Table1LastName: TStringField;
    Table1FirstName: TStringField;
    Table1PhoneExt: TStringField;
    Table1HireDate: TDateTimeField;
    Table1Salary: TFloatField;
    procedure CloseButtonClick(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure EditButtonClick(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EmployeeGrid: TEmployeeGrid;

procedure DoEmployeeGrid(Sender: TAMDIEngine;ParentForm:TForm);

implementation

uses ordrcard,emplcard;

{$R *.DFM}

procedure DoEmployeeGrid(Sender: TAMDIEngine;ParentForm:TForm);
begin
  with Sender do
  begin
    NewForm(TEmployeeGrid);
    if ParentForm<>nil then
      with ActiveForm as TEmployeeGrid do
      begin
        SelectButton.Visible:=true;
        DBGrid1.OnDblClick:=SelectButtonClick;
      end;
    ShowForm;
    while Not (Terminated or (ActiveState=AMDICloseState)) do
    begin
      case ActiveState of
      1,2:
        begin
          ActiveState:=0;
          DoEmployeeCard(Sender,ActiveForm);
        end;
      3:
        begin
          ActiveState:=0;
          if ParentForm<>nil then
            if ParentForm is TOrderCard then
               TOrderCard(ParentForm).DataSource1.Dataset.FieldByName('EmpNo').asInteger:=
                (ActiveForm as TEmployeeGrid).Table1.FieldByName('EmpNo').asInteger;
          break;
        end;
      else
        sleep(100);
      end;
    end;
    CloseForm;
  end;
end;

procedure TEmployeeGrid.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TEmployeeGrid.InsertButtonClick(Sender: TObject);
var LastNo:integer;
begin
  if Table1.isEmpty then
    LastNo:=1
  else
  begin
    Table1.IndexFieldNames:='EmpNo';
    Table1.Last;
    LastNo:=Table1.FieldByName('EmpNo').asInteger+1;
    Table1.IndexName:='ByName';
  end;
  Table1.Insert;
  Table1.FieldByName('EmpNo').asInteger:=LastNo;
  AMDIEngines.States[Self]:=1;
end;

procedure TEmployeeGrid.EditButtonClick(Sender: TObject);
begin
  if not Table1.IsEmpty then
  begin
    Table1.Edit;
    AMDIEngines.States[Self]:=2;
  end;
end;

procedure TEmployeeGrid.SelectButtonClick(Sender: TObject);
begin
  if not Table1.IsEmpty then
  begin
    AMDIEngines.States[Self]:=3;
  end;
end;

procedure TEmployeeGrid.DeleteButtonClick(Sender: TObject);
begin
  if not Table1.IsEmpty then
  begin
    if MessageDlg('Delete this record?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      Table1.Delete;
  end;
end;

end.
