unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, AMDI;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Data1: TMenuItem;
    Window1: TMenuItem;
    Customers1: TMenuItem;
    Employee1: TMenuItem;
    CloseAll1: TMenuItem;
    N2: TMenuItem;
    Quit1: TMenuItem;
    CustomerEngine: TAMDIEngine;
    EmployeeEngine: TAMDIEngine;
    procedure Window1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Customers1Click(Sender: TObject);
    procedure Employee1Click(Sender: TObject);
    procedure CustomerEngineExecute(Sender: TObject);
    procedure EmployeeEngineExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure Window1SelectClick(Sender: TObject);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses custgrid,emplgrid;

{$R *.DFM}

procedure TMainForm.Window1Click(Sender: TObject);
var i,id:integer;
    mi:TMenuItem;
    e:TAMDIEngine;
begin
  { Show form captions }
  for i:=Window1.Count-1 downto 1 do
    Window1.Items[i].Free;
  if MDIChildCount>0 then
  begin
    mi:=TMenuItem.Create(Self);
    mi.Caption:='-';
    Window1.Add(mi);
  end;
  For i:=0 to MDIChildCount-1 do
  begin
    mi:=TMenuItem.Create(Self);
    mi.Caption:=MDIChildren[i].Caption;
    mi.Enabled:=MDIChildren[i].Enabled;
    mi.OnClick:=Window1SelectClick;
    e:=AMDIEngines.FindByForm(MDIChildren[i]);
    id:=0;
    if e<>nil then
      id:=e.EngineID;
    mi.Tag:=id;
    Window1.Add(mi);
  end;
end;

procedure TMainForm.CloseAll1Click(Sender: TObject);
begin
  AMDIEngines.TerminateAll;
end;

procedure TMainForm.Window1SelectClick(Sender: TObject);
var id:integer;
    e:TAMDIEngine;
begin
  id:=(Sender as TMenuItem).Tag;
  if id>0 then
  begin
    e:=AMDIEngines.FindByID(id);
    e.Execute;
  end;
end;

procedure TMainForm.Quit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Customers1Click(Sender: TObject);
begin
  CustomerEngine.Execute;
end;

procedure TMainForm.Employee1Click(Sender: TObject);
begin
  EmployeeEngine.Execute;
end;

procedure TMainForm.CustomerEngineExecute(Sender: TObject);
begin
  DoCustomerGrid(Sender as TAMDIEngine,nil);
end;

procedure TMainForm.EmployeeEngineExecute(Sender: TObject);
begin
  DoEmployeeGrid(Sender as TAMDIEngine,nil);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  AMDIEngines.TerminateAll;
end;

end.
